import re


def sanitize(data, endpoint):
	def regex_clean(target_string, spaces):
		if spaces == True:
			space = '\s'

		else:
			space = ''

		return re.sub(r'([^a-zA-Z@_.,\-\d/\[\]\'\:{}]+)'.format(space), '', target_string).strip()

	target = {}

	for k,v in data.items():
		if k == 'name':
			target[k] = regex_clean(data[v], True)

		if k == 'scope':
			k = 'scopes'

		#if k == 'scopes':
			#target[k] = []
			#for scope in v.split(' '):
				#target[k].append(regex_clean(scope, False))

		else:
			target[k] = regex_clean(v, False)

	return target
