import asyncio
import sys
import os
import json
import re

from urllib.parse import urlparse
from sanic.views import HTTPMethodView
from sanic.response import json as rjson

from ..database import get, put, update, delete
from ..web_functions import error, jresp
from ..config import config, logging


class post_cmd:
	def test(data):
		return ['fuck']

	def register(data):
		display = data.get('display', data['handle'])
		handle = data.get('handle')
		email = data.get('email')
		password = data.get('password')
		bio = data.get('bio')
		table = data.get('table')
		sig = data.get('sig')

		if None in [handle, email, password]:
			error(request, 400, 'MissingParameters')

		if table == None:
			table == {}

		user = create_user(handle, email, password, display, bio, table, sig)

		return {'token': user['token']}


	def token(data):
		pass


	def password(data):
		token = data['token']
		password = data.get('password')

		if password == None:
			return error(request, 400, 'MissingNewPassword')

		msg = change_pass(password, token)

		return {'msg': 'UpdatedPassword'} if msg == True else {'err': 'EmailNotExist'}


# While this does allow an infinite amount of posts, it's not gonna stay like this
	def status(data):
		def check_data(post):
			if isinstance(post, dict) == False:
				return error(request, 400, 'NotDict')

			post_data = {
				'text': post.get('text'),
				'warning': post.get('warning'),
				'privacy': post.get('privacy'),
				'token': post.get('token'),
				'media_id': post.get('media_id'),
				'reply_id': post.get('reply_id')
			}

			if post_data['text'] == None:
				return error(request, 400, 'MissingData')

			if post_data['privacy'] == None:
				post_data['privacy'] = 'public'

			elif post_data['privacy'] not in ['public', 'unlisted', 'locked', 'direct']:
				return error(request, 400, 'InvalidPrivacyLevel')

			return post_data
		# End post checking

		token_data = get.api_token(data['token'])

		if token_data == None:
			return error(request, 401, 'InvalidToken')

		if 'posts' in data:
			if isinstance(data['posts'], list) == False:
				return error(request, 400, 'NotList')

			posts = []
			msg = ''

			for raw_post in data['posts']:
				post = check_data(raw_post)
				posts.append({
					'text': post['text'],
					'warning': post['warning'],
					'privacy': post['privacy'],
					'media_id': post['media_id'],
					'reply_id': post['reply_id']
				})

		elif 'text' in data:
			post = check_data(data)

			posts = [{
				'text': post['text'],
				'warning': post['warning'],
				'privacy': post['privacy'],
				'media_id': post['media_id'],
				'reply_id': post['reply_id']
			}]

		else:
			error(request, 400, 'InvalidData')

		return put.local_post2(token_data['userid'], posts)


	def getuser(data):
		user = get_profile(data['user'])

		if user == False:
			return {'err': 'UserNotExist'}

		else:
			return user


	def bio(data):
		bio = data.get('bio')

		if bio == None:
			error(request, 400, 'MissingBio')

		msg = update_bio(data['token'], bio)

		if msg == False:
			error(request, 500, 'FailedToUpdateDB')

		else:
			return {'msg': 'BioUpdated'}


	def tables(data):
		tables = data.get('tables')

		if tables == None:
			error(request, 400, 'MissingTables')

		msg = update_tables(data['token'], tables)

		if msg == False:
			error(request, 500, 'FailedToUpdateDB')

		else:
			return {'msg': 'TablesUpdated'}

#-----------------------

class get_cmd:
	def instance(data):
		return 'YEET'


	def posts(data):
		pass

#----------------------

def sanitize(data, endpoint):
	def regex_clean(target_string, spaces):
		if spaces == True:
			return re.sub(r'([^a-zA-Z@_.\-\d\s]+)', '', target_string).strip()

		else:
			return re.sub(r'([^a-zA-Z@_.\-\d]+)', '', target_string).strip()

	target = []

	for line in data:
		if data[0] == 'name':
			target.append(regex_clean(line, True))

		else:
			target.append(regex_clean(line, False))

	return target


class handle(HTTPMethodView):
	async def post(request):
		command = request.match_info['name']
		#data = sanitize(await request.json(), command)

		try:
			data = await request.json()
			#data['client_ip'] = request.headers['X-Real-Ip']
			data['token'] = request.headers['Token'] if 'Token' in request.headers else None

		except:
			error(request, 400, 'InvalidData')

		if callable(getattr(post_cmd, command, True)):
			msg = eval('post_cmd.'+command+'(data)')

		else:
			error(request, 404, 'InvalidCommand')

		return jresp(msg)


	async def get(request):
		command = request.match_info['name']

		data['client_ip'] = request.headers['X-Real-Ip']
		data['token'] = request.headers['Token'] if 'Token' in request.headers else error(request, 401, 'InvalidToken')

		if callable(getattr(get_cmd, command, True)):
			msg = eval('get_cmd.'+command+'(data)')

		else:
			error(request, 404, 'InvalidCommand')

		return jresp(msg)
