import aiohttp
import aiohttp_jinja2

from social.config import script_path

async def main(request):
	return aiohttp_jinja2.render_template('pages/main.html', request, None)

async def modules(request):
	module = request.match_info['module']
	return aiohttp.web.FileResponse(f'{script_path}/webapp/js/{module}.py')
